Index: issm/trunk-jpl/src/c/classes/Materials/Matdamageice.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Materials/Matdamageice.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Materials/Matdamageice.h	(revision 15564)
@@ -52,5 +52,5 @@
 		void   GetViscosity2d(IssmDouble* pviscosity, IssmDouble* pepsilon);
 		void   GetViscosity3d(IssmDouble* pviscosity3d, IssmDouble* pepsilon);
-		void   GetViscosity3dStokes(IssmDouble* pviscosity3d, IssmDouble* epsilon);
+		void   GetViscosity3dFS(IssmDouble* pviscosity3d, IssmDouble* epsilon);
 		void   GetViscosityComplement(IssmDouble* pviscosity_complement, IssmDouble* pepsilon);
 		void   GetViscosityZComplement(IssmDouble* pviscosity_complement, IssmDouble* pepsilon);
Index: issm/trunk-jpl/src/c/classes/Materials/Material.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Materials/Material.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Materials/Material.h	(revision 15564)
@@ -28,5 +28,5 @@
 		virtual void       GetViscosity2d(IssmDouble* pviscosity, IssmDouble* pepsilon)=0;
 		virtual void       GetViscosity3d(IssmDouble* pviscosity3d, IssmDouble* pepsilon)=0;
-		virtual void       GetViscosity3dStokes(IssmDouble* pviscosity3d, IssmDouble* epsilon)=0;
+		virtual void       GetViscosity3dFS(IssmDouble* pviscosity3d, IssmDouble* epsilon)=0;
 		virtual void       GetViscosityComplement(IssmDouble* pviscosity_complement, IssmDouble* pepsilon)=0;
 		virtual void       GetViscosityZComplement(IssmDouble* pviscosity_complement, IssmDouble* pepsilon)=0;
Index: issm/trunk-jpl/src/c/classes/Materials/Matice.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Materials/Matice.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Materials/Matice.cpp	(revision 15564)
@@ -342,6 +342,6 @@
 }
 /*}}}*/
-/*FUNCTION Matice::GetViscosity3dStokes {{{*/
-void  Matice::GetViscosity3dStokes(IssmDouble* pviscosity3d, IssmDouble* epsilon){
+/*FUNCTION Matice::GetViscosity3dFS {{{*/
+void  Matice::GetViscosity3dFS(IssmDouble* pviscosity3d, IssmDouble* epsilon){
 	/*Return viscosity accounting for steady state power law creep [Thomas and MacAyeal, 1982]: 
 	 *
Index: issm/trunk-jpl/src/c/classes/Materials/Matice.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Materials/Matice.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Materials/Matice.h	(revision 15564)
@@ -59,5 +59,5 @@
 		void       GetViscosity2d(IssmDouble* pviscosity, IssmDouble* pepsilon);
 		void       GetViscosity3d(IssmDouble* pviscosity3d, IssmDouble* pepsilon);
-		void       GetViscosity3dStokes(IssmDouble* pviscosity3d, IssmDouble* epsilon);
+		void       GetViscosity3dFS(IssmDouble* pviscosity3d, IssmDouble* epsilon);
 		void       GetViscosityComplement(IssmDouble* pviscosity_complement, IssmDouble* pepsilon);
 		void GetViscosityZComplement(IssmDouble*, IssmDouble*){_error_("not supported");};
Index: issm/trunk-jpl/src/c/classes/Materials/Matpar.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Materials/Matpar.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Materials/Matpar.h	(revision 15564)
@@ -89,5 +89,5 @@
 		void       GetViscosity2d(IssmDouble* pviscosity, IssmDouble* pepsilon){_error_("not supported");};
 		void       GetViscosity3d(IssmDouble* pviscosity3d, IssmDouble* pepsilon){_error_("not supported");};
-		void       GetViscosity3dStokes(IssmDouble* pviscosity3d, IssmDouble* epsilon){_error_("not supported");};
+		void       GetViscosity3dFS(IssmDouble* pviscosity3d, IssmDouble* epsilon){_error_("not supported");};
 		void       GetViscosityComplement(IssmDouble* pviscosity_complement, IssmDouble* pepsilon){_error_("not supported");};
 		void       GetViscosityZComplement(IssmDouble* pviscosity_complement, IssmDouble* pepsilon){_error_("not supported");};
Index: issm/trunk-jpl/src/c/classes/Node.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Node.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Node.cpp	(revision 15564)
@@ -83,10 +83,10 @@
 				this->Deactivate();
 			}
-			if(node_type==MacAyealPattynApproximationEnum && reCast<int>(iomodel->Data(FlowequationBordermacayealEnum)[io_index])){
+			if(node_type==MacAyealHOApproximationEnum && reCast<int>(iomodel->Data(FlowequationBorderSSAEnum)[io_index])){
 				if(!reCast<int>(iomodel->Data(MeshVertexonbedEnum)[io_index])){
 					this->Deactivate();
 				}
 			}
-			if(node_type==MacAyealStokesApproximationEnum && reCast<int>(iomodel->Data(FlowequationBordermacayealEnum)[io_index])){
+			if(node_type==MacAyealFSApproximationEnum && reCast<int>(iomodel->Data(FlowequationBorderSSAEnum)[io_index])){
 				if(!reCast<int>(iomodel->Data(MeshVertexonbedEnum)[io_index])){
 					for(k=1;k<=2;k++) this->FreezeDof(k);
@@ -94,6 +94,6 @@
 			}
 		}
-		/*spc all nodes on hutter*/
-		if(node_type==HutterApproximationEnum){
+		/*spc all nodes on SIA*/
+		if(node_type==SIAApproximationEnum){
 			this->Deactivate();
 		}
@@ -101,9 +101,9 @@
 	#endif
 
-	/*Diagnostic Hutter*/
-	if(analysis_type==DiagnosticHutterAnalysisEnum){
+	/*Diagnostic SIA*/
+	if(analysis_type==DiagnosticSIAAnalysisEnum){
 		_assert_(iomodel->Data(FlowequationVertexEquationEnum));
-		/*Constrain all nodes that are not Hutter*/
-		if(reCast<int>(node_type)!=HutterApproximationEnum){
+		/*Constrain all nodes that are not SIA*/
+		if(reCast<int>(node_type)!=SIAApproximationEnum){
 			this->Deactivate();
 		}
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/CreateDataSets.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/CreateDataSets.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/CreateDataSets.cpp	(revision 15564)
@@ -55,9 +55,9 @@
 			break;
 
-		case DiagnosticHutterAnalysisEnum:
-			CreateNodesDiagnosticHutter(pnodes, iomodel);
-			CreateConstraintsDiagnosticHutter(pconstraints,iomodel);
-			CreateLoadsDiagnosticHutter(ploads,iomodel);
-			UpdateElementsDiagnosticHutter(elements,iomodel,analysis_counter,analysis_type);
+		case DiagnosticSIAAnalysisEnum:
+			CreateNodesDiagnosticSIA(pnodes, iomodel);
+			CreateConstraintsDiagnosticSIA(pconstraints,iomodel);
+			CreateLoadsDiagnosticSIA(ploads,iomodel);
+			UpdateElementsDiagnosticSIA(elements,iomodel,analysis_counter,analysis_type);
 			break;
 		#endif
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/CreateParameters.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/CreateParameters.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/CreateParameters.cpp	(revision 15564)
@@ -45,10 +45,10 @@
 	/*Copy some constants from iomodel */
 	parameters->AddObject(iomodel->CopyConstantObject(MeshDimensionEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(FlowequationIshutterEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(FlowequationIsmacayealEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(FlowequationIsl1l2Enum));
-	parameters->AddObject(iomodel->CopyConstantObject(FlowequationIspattynEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(FlowequationIsstokesEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(FlowequationFeStokesEnum));
+	parameters->AddObject(iomodel->CopyConstantObject(FlowequationIsSIAEnum));
+	parameters->AddObject(iomodel->CopyConstantObject(FlowequationIsSSAEnum));
+	parameters->AddObject(iomodel->CopyConstantObject(FlowequationIsL1L2Enum));
+	parameters->AddObject(iomodel->CopyConstantObject(FlowequationIsHOEnum));
+	parameters->AddObject(iomodel->CopyConstantObject(FlowequationIsFSEnum));
+	parameters->AddObject(iomodel->CopyConstantObject(FlowequationFeFSEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(SettingsOutputFrequencyEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(DiagnosticRestolEnum));
@@ -82,5 +82,5 @@
 	parameters->AddObject(iomodel->CopyConstantObject(ThermalPenaltyLockEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(DiagnosticRiftPenaltyThresholdEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(DiagnosticStokesreconditioningEnum));
+	parameters->AddObject(iomodel->CopyConstantObject(DiagnosticFSreconditioningEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(DiagnosticShelfDampeningEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(DiagnosticViscosityOvershootEnum));
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateConstraintsDiagnosticHoriz.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateConstraintsDiagnosticHoriz.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateConstraintsDiagnosticHoriz.cpp	(revision 15564)
@@ -16,6 +16,6 @@
 	IssmDouble g;
 	IssmDouble rho_ice;
-	IssmDouble stokesreconditioning;
-	bool       ismacayeal,isl1l2,ispattyn,isstokes;
+	IssmDouble FSreconditioning;
+	bool       isSSA,isL1L2,isHO,isFS;
 	int        fe_ssa;
 	bool       spcpresent = false;
@@ -26,7 +26,7 @@
 	IssmDouble *spcvy          = NULL;
 	IssmDouble *spcvz          = NULL;
-	IssmDouble *nodeonmacayeal = NULL;
-	IssmDouble *nodeonpattyn   = NULL;
-	IssmDouble *nodeonstokes   = NULL;
+	IssmDouble *nodeonSSA = NULL;
+	IssmDouble *nodeonHO   = NULL;
+	IssmDouble *nodeonFS   = NULL;
 	IssmDouble *nodeonbed      = NULL;
 	IssmDouble *nodeonicesheet = NULL;
@@ -47,16 +47,16 @@
 	iomodel->Constant(&g,ConstantsGEnum);
 	iomodel->Constant(&rho_ice,MaterialsRhoIceEnum);
-	iomodel->Constant(&stokesreconditioning,DiagnosticStokesreconditioningEnum);
-	iomodel->Constant(&ismacayeal,FlowequationIsmacayealEnum);
-	iomodel->Constant(&isl1l2,FlowequationIsl1l2Enum);
-	iomodel->Constant(&ispattyn,FlowequationIspattynEnum);
-	iomodel->Constant(&isstokes,FlowequationIsstokesEnum);
-	iomodel->Constant(&fe_ssa,FlowequationFeSsaEnum);
+	iomodel->Constant(&FSreconditioning,DiagnosticFSreconditioningEnum);
+	iomodel->Constant(&isSSA,FlowequationIsSSAEnum);
+	iomodel->Constant(&isL1L2,FlowequationIsL1L2Enum);
+	iomodel->Constant(&isHO,FlowequationIsHOEnum);
+	iomodel->Constant(&isFS,FlowequationIsFSEnum);
+	iomodel->Constant(&fe_ssa,FlowequationFeSSAEnum);
 
 	/*Recover pointer: */
 	constraints=*pconstraints;
 
-	/*Now, is the flag macayaealpattyn on? otherwise, do nothing: */
-	if(!ismacayeal & !ispattyn & !isstokes & !isl1l2){
+	/*Now, is the flag macayaealHO on? otherwise, do nothing: */
+	if(!isSSA & !isHO & !isFS & !isL1L2){
 		*pconstraints=constraints;
 		return;
@@ -67,7 +67,7 @@
 	iomodel->FetchData(&spcvy,&My,&Ny,DiagnosticSpcvyEnum);
 	iomodel->FetchData(&spcvz,&Mz,&Nz,DiagnosticSpcvzEnum);
-	iomodel->FetchData(&nodeonmacayeal,NULL,NULL,FlowequationBordermacayealEnum);
-	if(iomodel->dim==3)iomodel->FetchData(&nodeonpattyn,NULL,NULL,FlowequationBorderpattynEnum);
-	if(iomodel->dim==3)iomodel->FetchData(&nodeonstokes,NULL,NULL,FlowequationBorderstokesEnum);
+	iomodel->FetchData(&nodeonSSA,NULL,NULL,FlowequationBorderSSAEnum);
+	if(iomodel->dim==3)iomodel->FetchData(&nodeonHO,NULL,NULL,FlowequationBorderHOEnum);
+	if(iomodel->dim==3)iomodel->FetchData(&nodeonFS,NULL,NULL,FlowequationBorderFSEnum);
 	if(iomodel->dim==3)iomodel->FetchData(&nodeonbed,NULL,NULL,MeshVertexonbedEnum);
 	if(iomodel->dim==3)iomodel->FetchData(&nodeonicesheet,NULL,NULL,MaskVertexongroundediceEnum);
@@ -99,8 +99,8 @@
 		if(iomodel->my_vertices[i]){
 
-			/*Start with adding spcs of coupling: zero at the border macayeal/pattyn for the appropriate dofs*/
-			if (reCast<int,IssmDouble>(vertices_type[i]==MacAyealPattynApproximationEnum)){
-				/*If grionmacayeal, spc pattyn dofs: 3 & 4*/
-					if (reCast<int,IssmDouble>(nodeonpattyn[i])){
+			/*Start with adding spcs of coupling: zero at the border SSA/HO for the appropriate dofs*/
+			if (reCast<int,IssmDouble>(vertices_type[i]==MacAyealHOApproximationEnum)){
+				/*If grionSSA, spc HO dofs: 3 & 4*/
+					if (reCast<int,IssmDouble>(nodeonHO[i])){
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,0,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 						count++;
@@ -117,5 +117,5 @@
 
 					}
-					else if (reCast<int,IssmDouble>(nodeonmacayeal[i])){
+					else if (reCast<int,IssmDouble>(nodeonSSA[i])){
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,3,0,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 						count++;
@@ -132,10 +132,10 @@
 
 					}
-					else _error_("if vertices_type is MacAyealPattyn, you shoud have nodeonpattyn or nodeonmacayeal");
-			}
-			/*Also add spcs of coupling: zero at the border pattyn/stokes for the appropriate dofs*/
-			else if (reCast<int,IssmDouble>(vertices_type[i])==PattynStokesApproximationEnum){
-				/*If grion,pattyn spc stokes dofs: 3 4 & 5*/
-					if (reCast<int,IssmDouble>(nodeonpattyn[i])){
+					else _error_("if vertices_type is MacAyealHO, you shoud have nodeonHO or nodeonSSA");
+			}
+			/*Also add spcs of coupling: zero at the border HO/FS for the appropriate dofs*/
+			else if (reCast<int,IssmDouble>(vertices_type[i])==HOFSApproximationEnum){
+				/*If grion,HO spc FS dofs: 3 4 & 5*/
+					if (reCast<int,IssmDouble>(nodeonHO[i])){
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,3,0,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 						count++;
@@ -154,5 +154,5 @@
 
 					}
-					else if (reCast<int,IssmDouble>(nodeonstokes[i])){ //spc pattyn nodes: 1 & 2
+					else if (reCast<int,IssmDouble>(nodeonFS[i])){ //spc HO nodes: 1 & 2
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,0,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 						count++;
@@ -172,10 +172,10 @@
 						}
 					}
-					else _error_("if vertices_type is PattynStokes, you shoud have nodeonpattyn or nodeonstokes");
-			}
-			/*Also add spcs of coupling: zero at the border pattyn/stokes for the appropriate dofs*/
-			else if (reCast<int,IssmDouble>(vertices_type[i])==MacAyealStokesApproximationEnum){
-				/*If grion,pattyn spc stokes dofs: 3 4 & 5*/
-					if (reCast<int,IssmDouble>(nodeonmacayeal[i])){
+					else _error_("if vertices_type is HOFS, you shoud have nodeonHO or nodeonFS");
+			}
+			/*Also add spcs of coupling: zero at the border HO/FS for the appropriate dofs*/
+			else if (reCast<int,IssmDouble>(vertices_type[i])==MacAyealFSApproximationEnum){
+				/*If grion,HO spc FS dofs: 3 4 & 5*/
+					if (reCast<int,IssmDouble>(nodeonSSA[i])){
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,3,0,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 						count++;
@@ -194,5 +194,5 @@
 
 					}
-					else if (reCast<int,IssmDouble>(nodeonstokes[i])){ //spc macayeal nodes: 1 & 2
+					else if (reCast<int,IssmDouble>(nodeonFS[i])){ //spc SSA nodes: 1 & 2
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,0,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 						count++;
@@ -212,5 +212,5 @@
 						}
 					}
-					else _error_("if vertices_type is MacAyealStokes, you shoud have nodeonmacayeal or nodeonstokes");
+					else _error_("if vertices_type is MacAyealFS, you shoud have nodeonSSA or nodeonFS");
 			}
 			/*Now add the regular spcs*/
@@ -236,5 +236,5 @@
 					xDelete<IssmDouble>(values);
 				}
-				else if (vertices_type[i]==HutterApproximationEnum){
+				else if (vertices_type[i]==SIAApproximationEnum){
 					constraints->AddObject(new SpcDynamic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,DiagnosticHorizAnalysisEnum));
 					count++;
@@ -259,10 +259,10 @@
 					xDelete<IssmDouble>(values);
 				}
-				else if (vertices_type[i]==HutterApproximationEnum){
+				else if (vertices_type[i]==SIAApproximationEnum){
 					constraints->AddObject(new SpcDynamic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,2,DiagnosticHorizAnalysisEnum));
 					count++;
 				}
 
-				if (reCast<int,IssmDouble>(vertices_type[i])==StokesApproximationEnum ||  (reCast<int,IssmDouble>(vertices_type[i])==NoneApproximationEnum)){
+				if (reCast<int,IssmDouble>(vertices_type[i])==FSApproximationEnum ||  (reCast<int,IssmDouble>(vertices_type[i])==NoneApproximationEnum)){
 					if (Mz==iomodel->numberofvertices && !xIsNan<IssmDouble>(spcvz[i])){
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,3,spcvz[i]/yts,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 2 to vy
@@ -286,5 +286,5 @@
 				}
 				if (reCast<int,IssmDouble>(vertices_type[i])==NoneApproximationEnum){
-					constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,4,g*rho_ice*(surface[i]-z[i])/stokesreconditioning,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 2 to vy
+					constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,4,g*rho_ice*(surface[i]-z[i])/FSreconditioning,DiagnosticHorizAnalysisEnum)); //add count'th spc, on node i+1, setting dof 2 to vy
 					count++;
 				}
@@ -292,15 +292,15 @@
 
 			/*Constraint at the bedrock interface (v.n = vz = 0) (Coordinates will be updated according to the bed slope)*/
-			if (iomodel->dim==3) if(reCast<int,IssmDouble>(nodeonbed[i]) && reCast<int,IssmDouble>(nodeonicesheet[i]) && reCast<int,IssmDouble>(nodeonstokes[i])){
+			if (iomodel->dim==3) if(reCast<int,IssmDouble>(nodeonbed[i]) && reCast<int,IssmDouble>(nodeonicesheet[i]) && reCast<int,IssmDouble>(nodeonFS[i])){
 				 switch(reCast<int,IssmDouble>(vertices_type[i])){
-					case MacAyealStokesApproximationEnum:
+					case MacAyealFSApproximationEnum:
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,5,0.,DiagnosticHorizAnalysisEnum));
 						count++;
 						break;
-					case PattynStokesApproximationEnum:
+					case HOFSApproximationEnum:
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,5,0.,DiagnosticHorizAnalysisEnum));
 						count++;
 						break;
-					case StokesApproximationEnum:
+					case FSApproximationEnum:
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,3,0.,DiagnosticHorizAnalysisEnum));
 						count++;
@@ -313,5 +313,5 @@
 
 	/*SPC Quadratic elements*/
-	if(ismacayeal && fe_ssa==1){
+	if(isSSA && fe_ssa==1){
 
 		int   v1,v2;
@@ -338,5 +338,5 @@
 					count++;
 				}
-				if (reCast<int,IssmDouble>(vertices_type[v1])==StokesApproximationEnum ||  (reCast<int,IssmDouble>(vertices_type[v1])==NoneApproximationEnum)){
+				if (reCast<int,IssmDouble>(vertices_type[v1])==FSApproximationEnum ||  (reCast<int,IssmDouble>(vertices_type[v1])==NoneApproximationEnum)){
 					if(!xIsNan<IssmDouble>(spcvz[v1]) && !xIsNan<IssmDouble>(spcvz[v2])){
 						constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+iomodel->numberofvertices+i+1,
@@ -356,7 +356,7 @@
 	iomodel->DeleteData(spcvy,DiagnosticSpcvyEnum);
 	iomodel->DeleteData(spcvz,DiagnosticSpcvzEnum);
-	iomodel->DeleteData(nodeonmacayeal,FlowequationBordermacayealEnum);
-	if(iomodel->dim==3)iomodel->DeleteData(nodeonpattyn,FlowequationBorderpattynEnum);
-	if(iomodel->dim==3)iomodel->DeleteData(nodeonstokes,FlowequationBorderstokesEnum);
+	iomodel->DeleteData(nodeonSSA,FlowequationBorderSSAEnum);
+	if(iomodel->dim==3)iomodel->DeleteData(nodeonHO,FlowequationBorderHOEnum);
+	if(iomodel->dim==3)iomodel->DeleteData(nodeonFS,FlowequationBorderFSEnum);
 	if(iomodel->dim==3)iomodel->DeleteData(nodeonbed,MeshVertexonbedEnum);
 	if(iomodel->dim==3)iomodel->DeleteData(nodeonicesheet,MaskVertexongroundediceEnum);
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateLoadsDiagnosticHoriz.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateLoadsDiagnosticHoriz.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateLoadsDiagnosticHoriz.cpp	(revision 15564)
@@ -19,5 +19,5 @@
 	int         count;
 	int         penpair_ids[2];
-	bool        ismacayeal,isl1l2,ispattyn,isstokes;
+	bool        isSSA,isL1L2,isHO,isFS;
 	int         numpenalties,numberofpressureloads,numrifts,numriftsegments;
 	IssmDouble *pressureload   = NULL;
@@ -26,5 +26,5 @@
 	IssmDouble *riftinfo       = NULL;
 	IssmDouble *nodeonbed      = NULL;
-	IssmDouble *nodeonstokes   = NULL;
+	IssmDouble *nodeonFS   = NULL;
 	IssmDouble *nodeonicesheet = NULL;
 	IssmDouble *vertices_type  = NULL;
@@ -32,8 +32,8 @@
 
 	/*Fetch parameters: */
-	iomodel->Constant(&isl1l2,FlowequationIsl1l2Enum);
-	iomodel->Constant(&isstokes,FlowequationIsstokesEnum);
-	iomodel->Constant(&ismacayeal,FlowequationIsmacayealEnum);
-	iomodel->Constant(&ispattyn,FlowequationIspattynEnum);
+	iomodel->Constant(&isL1L2,FlowequationIsL1L2Enum);
+	iomodel->Constant(&isFS,FlowequationIsFSEnum);
+	iomodel->Constant(&isSSA,FlowequationIsSSAEnum);
+	iomodel->Constant(&isHO,FlowequationIsHOEnum);
 	iomodel->Constant(&numrifts,RiftsNumriftsEnum);
 
@@ -41,6 +41,6 @@
 	Loads* loads=*ploads;
 
-	/*Now, is the flag macayaealpattyn on? otherwise, do nothing: */
-	if(!ismacayeal & !ispattyn & !isstokes & !isl1l2) return;
+	/*Now, is the flag macayaealHO on? otherwise, do nothing: */
+	if(!isSSA & !isHO & !isFS & !isL1L2) return;
 
 	/*Initialize counter: */
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateNodesDiagnosticHoriz.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateNodesDiagnosticHoriz.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateNodesDiagnosticHoriz.cpp	(revision 15564)
@@ -12,19 +12,19 @@
 
 	/*Intermediary*/
-	bool   ismacayeal,isl1l2,ispattyn,isstokes;
+	bool   isSSA,isL1L2,isHO,isFS;
 	int    finiteelementssa;
 
 	/*Fetch parameters: */
-	iomodel->Constant(&ismacayeal,FlowequationIsmacayealEnum);
-	iomodel->Constant(&isl1l2,FlowequationIsl1l2Enum);
-	iomodel->Constant(&ispattyn,FlowequationIspattynEnum);
-	iomodel->Constant(&isstokes,FlowequationIsstokesEnum);
-	iomodel->Constant(&finiteelementssa,FlowequationFeSsaEnum);
+	iomodel->Constant(&isSSA,FlowequationIsSSAEnum);
+	iomodel->Constant(&isL1L2,FlowequationIsL1L2Enum);
+	iomodel->Constant(&isHO,FlowequationIsHOEnum);
+	iomodel->Constant(&isFS,FlowequationIsFSEnum);
+	iomodel->Constant(&finiteelementssa,FlowequationFeSSAEnum);
 
-	/*Now, is the flag macayaealpattyn on? otherwise, do nothing: */
-	if(!ismacayeal & !isl1l2 & !ispattyn & !isstokes) return;
+	/*Now, is the flag macayaealHO on? otherwise, do nothing: */
+	if(!isSSA & !isL1L2 & !isHO & !isFS) return;
 
 	/*Create nodes: */
-	iomodel->FetchData(9,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,FlowequationBordermacayealEnum,FlowequationBorderstokesEnum,
+	iomodel->FetchData(9,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,FlowequationBorderSSAEnum,FlowequationBorderFSEnum,
 				MaskVertexongroundediceEnum,MaskVertexonfloatingiceEnum,MaskVertexonwaterEnum,FlowequationVertexEquationEnum,DiagnosticReferentialEnum);
 	if(finiteelementssa==0){
@@ -37,5 +37,5 @@
 		_error_("finite element not supported yet");
 	}
-	iomodel->DeleteData(9,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,FlowequationBordermacayealEnum,FlowequationBorderstokesEnum,
+	iomodel->DeleteData(9,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,FlowequationBorderSSAEnum,FlowequationBorderFSEnum,
 				MaskVertexongroundediceEnum,MaskVertexonfloatingiceEnum,MaskVertexonwaterEnum,FlowequationVertexEquationEnum,DiagnosticReferentialEnum);
 }
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHoriz/UpdateElementsDiagnosticHoriz.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHoriz/UpdateElementsDiagnosticHoriz.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHoriz/UpdateElementsDiagnosticHoriz.cpp	(revision 15564)
@@ -17,19 +17,19 @@
 
 	int    materials_type;
-	bool   ismacayeal,isl1l2,ispattyn,isstokes;
+	bool   isSSA,isL1L2,isHO,isFS;
 	bool   control_analysis;
 	bool   dakota_analysis;
 
 	/*Fetch constants needed: */
-	iomodel->Constant(&ismacayeal,FlowequationIsmacayealEnum);
-	iomodel->Constant(&isl1l2,FlowequationIsl1l2Enum);
-	iomodel->Constant(&ispattyn,FlowequationIspattynEnum);
-	iomodel->Constant(&isstokes,FlowequationIsstokesEnum);
+	iomodel->Constant(&isSSA,FlowequationIsSSAEnum);
+	iomodel->Constant(&isL1L2,FlowequationIsL1L2Enum);
+	iomodel->Constant(&isHO,FlowequationIsHOEnum);
+	iomodel->Constant(&isFS,FlowequationIsFSEnum);
 	iomodel->Constant(&control_analysis,InversionIscontrolEnum);
 	iomodel->Constant(&dakota_analysis,QmuIsdakotaEnum);
 	iomodel->Constant(&materials_type,MaterialsEnum);
 
-	/*Now, is the flag macayaealpattyn on? otherwise, do nothing: */
-	if(!ismacayeal & !isl1l2 & !ispattyn & !isstokes) return;
+	/*Now, is the flag macayaealHO on? otherwise, do nothing: */
+	if(!isSSA & !isL1L2 & !isHO & !isFS) return;
 
 	/*Fetch data needed: */
@@ -72,5 +72,5 @@
 		iomodel->FetchDataToInput(elements,SurfaceforcingsMassBalanceEnum);
 		iomodel->FetchDataToInput(elements,BasalforcingsMeltingRateEnum);
-		iomodel->FetchDataToInput(elements,FlowequationBorderstokesEnum);
+		iomodel->FetchDataToInput(elements,FlowequationBorderFSEnum);
 		iomodel->FetchDataToInput(elements,LoadingforceZEnum);
 	}
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateConstraintsDiagnosticHutter.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateConstraintsDiagnosticHutter.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateConstraintsDiagnosticHutter.cpp	(revision 15564)
@@ -1,4 +1,4 @@
 /*
- * CreateConstraintsDiagnosticHutter.c:
+ * CreateConstraintsDiagnosticSIA.c:
  */
 
@@ -8,10 +8,10 @@
 #include "../ModelProcessorx.h"
 
-void	CreateConstraintsDiagnosticHutter(Constraints** pconstraints, IoModel* iomodel){
+void	CreateConstraintsDiagnosticSIA(Constraints** pconstraints, IoModel* iomodel){
 
 	/*Intermediary*/
 	int        count;
 	IssmDouble yts;
-	bool       ishutter;
+	bool       isSIA;
 
 	/*Output*/
@@ -24,8 +24,8 @@
 	/*Fetch parameters: */
 	iomodel->Constant(&yts,ConstantsYtsEnum);
-	iomodel->Constant(&ishutter,FlowequationIshutterEnum);
+	iomodel->Constant(&isSIA,FlowequationIsSIAEnum);
 
-	/*Now, is the flag ishutter on? otherwise, do nothing: */
-	if (!ishutter) return;
+	/*Now, is the flag isSIA on? otherwise, do nothing: */
+	if (!isSIA) return;
 
 	/*Fetch data: */
@@ -35,24 +35,24 @@
 	count=0;
 
-	/*vx and vy are spc'd if we are not on nodeonhutter: */
+	/*vx and vy are spc'd if we are not on nodeonSIA: */
 	for(int i=0;i<iomodel->numberofvertices;i++){
 		/*keep only this partition's nodes:*/
 		if((iomodel->my_vertices[i])){
-			if (!reCast<int,IssmDouble>(iomodel->Data(FlowequationVertexEquationEnum)[i])==HutterApproximationEnum){
+			if (!reCast<int,IssmDouble>(iomodel->Data(FlowequationVertexEquationEnum)[i])==SIAApproximationEnum){
 
-				constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,0,DiagnosticHutterAnalysisEnum));
+				constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,0,DiagnosticSIAAnalysisEnum));
 				count++;
 
-				constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,2,0,DiagnosticHutterAnalysisEnum));
+				constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,2,0,DiagnosticSIAAnalysisEnum));
 				count++;
 			}
 			else{
 				if (!xIsNan<IssmDouble>(iomodel->Data(DiagnosticSpcvxEnum)[i])){
-					constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,iomodel->Data(DiagnosticSpcvxEnum)[i]/yts,DiagnosticHutterAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
+					constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,iomodel->Data(DiagnosticSpcvxEnum)[i]/yts,DiagnosticSIAAnalysisEnum)); //add count'th spc, on node i+1, setting dof 1 to vx.
 					count++;
 				}
 
 				if (!xIsNan<IssmDouble>(iomodel->Data(DiagnosticSpcvyEnum)[i])){
-					constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,2,iomodel->Data(DiagnosticSpcvyEnum)[i]/yts,DiagnosticHutterAnalysisEnum)); //add count'th spc, on node i+1, setting dof 2 to vy
+					constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,2,iomodel->Data(DiagnosticSpcvyEnum)[i]/yts,DiagnosticSIAAnalysisEnum)); //add count'th spc, on node i+1, setting dof 2 to vy
 					count++;
 				}
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateLoadsDiagnosticHutter.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateLoadsDiagnosticHutter.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateLoadsDiagnosticHutter.cpp	(revision 15564)
@@ -1,3 +1,3 @@
-/*! \file CreateLoadsDiagnosticHutter.c:
+/*! \file CreateLoadsDiagnosticSIA.c:
  */
 
@@ -7,5 +7,5 @@
 #include "../ModelProcessorx.h"
 
-void	CreateLoadsDiagnosticHutter(Loads** ploads, IoModel* iomodel){
+void	CreateLoadsDiagnosticSIA(Loads** ploads, IoModel* iomodel){
 
 	/*No loads*/
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateNodesDiagnosticHutter.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateNodesDiagnosticHutter.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateNodesDiagnosticHutter.cpp	(revision 15564)
@@ -1,4 +1,4 @@
 /*
- * CreateNodesDiagnosticHutter.c:
+ * CreateNodesDiagnosticSIA.c:
  */
 
@@ -9,15 +9,15 @@
 #include "../ModelProcessorx.h"
 
-void	CreateNodesDiagnosticHutter(Nodes** pnodes, IoModel* iomodel){
+void	CreateNodesDiagnosticSIA(Nodes** pnodes, IoModel* iomodel){
 
 	/*Fetch parameters: */
-	bool ishutter;
-	iomodel->Constant(&ishutter,FlowequationIshutterEnum);
+	bool isSIA;
+	iomodel->Constant(&isSIA,FlowequationIsSIAEnum);
 
-	/*Now, is the flag ishutter on? otherwise, do nothing: */
-	if(!ishutter) return;
+	/*Now, is the flag isSIA on? otherwise, do nothing: */
+	if(!isSIA) return;
 
 	iomodel->FetchData(6,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,MaskVertexongroundediceEnum,MaskVertexonfloatingiceEnum,FlowequationVertexEquationEnum,MaskVertexonwaterEnum);
-	CreateNodes(pnodes,iomodel,DiagnosticHutterAnalysisEnum,P1Enum);
+	CreateNodes(pnodes,iomodel,DiagnosticSIAAnalysisEnum,P1Enum);
 	iomodel->DeleteData(6,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,MaskVertexongroundediceEnum,MaskVertexonfloatingiceEnum,FlowequationVertexEquationEnum,MaskVertexonwaterEnum);
 }
